(* THIS FILE IS AUTO GENERATED! SEE 'PosixPrimitive.def.sml' *)

structure PosixPrimitive =
   struct
      type fd = int
      type pid = int
      type uid = word
      type gid = word
      type signal = int
      type size = int
      type ssize = int
      type mode = word
      type time = int
      type file_desc = int

      structure CString :> sig
                             type cstring
                             val isNull : cstring -> bool
                             val toString : cstring -> string
                           end =
         struct
           type cstring = string
           fun isNull(s : string) : bool = prim("__is_null", s)
           fun toString x = x
         end
      type cstring = CString.cstring

      structure ForeignPtr : sig
                               type foreignptr
                               val isNull : foreignptr -> bool
                             end
                          =
         struct
           type foreignptr = foreignptr
           fun toInt (fp:foreignptr):int = prim("id",fp)
           fun isNull (fp:foreignptr) : bool = (toInt fp = 0)
         end

      structure Error =
         struct
            type syserror = int

            fun getErrno () : syserror =
              prim("Posix_Error_getErrno", ())

            fun clearErrno () : unit =
              prim("Posix_Error_clearErrno", ())

            fun strerror (e:syserror) : cstring =
              prim("Posix_Error_strerror", e)

            val acces = 13: syserror
            val again = 11: syserror
            val badf = 9: syserror
            val badmsg = 74: syserror
            val busy = 16: syserror
            val canceled = 125: syserror
            val child = 10: syserror
            val deadlk = 35: syserror
            val dom = 33: syserror
            val exist = 17: syserror
            val fault = 14: syserror
            val fbig = 27: syserror
            val inprogress = 115: syserror
            val intr = 4: syserror
            val inval = 22: syserror
            val io = 5: syserror
            val isdir = 21: syserror
            val loop = 40: syserror
            val mfile = 24: syserror
            val mlink = 31: syserror
            val msgsize = 90: syserror
            val nametoolong = 36: syserror
            val nfile = 23: syserror
            val nodev = 19: syserror
            val noent = 2: syserror
            val noexec = 8: syserror
            val nolck = 37: syserror
            val nomem = 12: syserror
            val nospc = 28: syserror
            val nosys = 38: syserror
            val notdir = 20: syserror
            val notempty = 39: syserror
            val notsup = 95: syserror
            val notty = 25: syserror
            val nxio = 6: syserror
            val perm = 1: syserror
            val pipe = 32: syserror
            val range = 34: syserror
            val rofs = 30: syserror
            val spipe = 29: syserror
            val srch = 3: syserror
            val toobig = 7: syserror
            val xdev = 18: syserror

            fun errorName (n:syserror) : string =
              case n
                of 13 => "acces"
                 | 11 => "again"
                 | 9 => "badf"
                 | 74 => "badmsg"
                 | 16 => "busy"
                 | 125 => "canceled"
                 | 10 => "child"
                 | 35 => "deadlk"
                 | 33 => "dom"
                 | 17 => "exist"
                 | 14 => "fault"
                 | 27 => "fbig"
                 | 115 => "inprogress"
                 | 4 => "intr"
                 | 22 => "inval"
                 | 5 => "io"
                 | 21 => "isdir"
                 | 40 => "loop"
                 | 24 => "mfile"
                 | 31 => "mlink"
                 | 90 => "msgsize"
                 | 36 => "nametoolong"
                 | 23 => "nfile"
                 | 19 => "nodev"
                 | 2 => "noent"
                 | 8 => "noexec"
                 | 37 => "nolck"
                 | 12 => "nomem"
                 | 28 => "nospc"
                 | 38 => "nosys"
                 | 20 => "notdir"
                 | 39 => "notempty"
                 | 95 => "notsup"
                 | 25 => "notty"
                 | 6 => "nxio"
                 | 1 => "perm"
                 | 32 => "pipe"
                 | 34 => "range"
                 | 30 => "rofs"
                 | 29 => "spipe"
                 | 3 => "srch"
                 | 7 => "toobig"
                 | 18 => "xdev"
                 | _ => "<UNKNOWN>"

            fun syserror (s:string) : syserror option =
              case s
                of "acces" => SOME 13
                 | "again" => SOME 11
                 | "badf" => SOME 9
                 | "badmsg" => SOME 74
                 | "busy" => SOME 16
                 | "canceled" => SOME 125
                 | "child" => SOME 10
                 | "deadlk" => SOME 35
                 | "dom" => SOME 33
                 | "exist" => SOME 17
                 | "fault" => SOME 14
                 | "fbig" => SOME 27
                 | "inprogress" => SOME 115
                 | "intr" => SOME 4
                 | "inval" => SOME 22
                 | "io" => SOME 5
                 | "isdir" => SOME 21
                 | "loop" => SOME 40
                 | "mfile" => SOME 24
                 | "mlink" => SOME 31
                 | "msgsize" => SOME 90
                 | "nametoolong" => SOME 36
                 | "nfile" => SOME 23
                 | "nodev" => SOME 19
                 | "noent" => SOME 2
                 | "noexec" => SOME 8
                 | "nolck" => SOME 37
                 | "nomem" => SOME 12
                 | "nospc" => SOME 28
                 | "nosys" => SOME 38
                 | "notdir" => SOME 20
                 | "notempty" => SOME 39
                 | "notsup" => SOME 95
                 | "notty" => SOME 25
                 | "nxio" => SOME 6
                 | "perm" => SOME 1
                 | "pipe" => SOME 32
                 | "range" => SOME 34
                 | "rofs" => SOME 30
                 | "spipe" => SOME 29
                 | "srch" => SOME 3
                 | "toobig" => SOME 7
                 | "xdev" => SOME 18
                 | _ => NONE
         end

      structure FileSys =
         struct
            type file_desc = file_desc

            type ino = int
            type dev = word
            type uid = uid
            type gid = gid

            structure S =
               struct
                  type mode = word
                  val ifsock = 0wxc000: mode (* 0140000 *)
                  val iflnk = 0wxa000: mode (* 0120000 *)
                  val ifreg = 0wx8000: mode (* 0100000 *)
                  val ifblk = 0wx6000: mode (* 0060000 *)
                  val ifdir = 0wx4000: mode (* 0040000 *)
                  val ifchr = 0wx2000: mode (* 0020000 *)
                  val ififo = 0wx1000: mode (* 0010000 *)
                  val irwxu = 0wx1c0: mode (* (0400|0200|0100) *)
                  val irusr = 0wx100: mode (* 0400 *)
                  val iwusr = 0wx80: mode (* 0200 *)
                  val ixusr = 0wx40: mode (* 0100 *)
                  val irwxg = 0wx38: mode (* ((0400|0200|0100) >> 3) *)
                  val irgrp = 0wx20: mode (* (0400 >> 3) *)
                  val iwgrp = 0wx10: mode (* (0200 >> 3) *)
                  val ixgrp = 0wx8: mode (* (0100 >> 3) *)
                  val irwxo = 0wx7: mode (* (((0400|0200|0100) >> 3) >> 3) *)
                  val iroth = 0wx4: mode (* ((0400 >> 3) >> 3) *)
                  val iwoth = 0wx2: mode (* ((0200 >> 3) >> 3) *)
                  val ixoth = 0wx1: mode (* ((0100 >> 3) >> 3) *)
                  val isuid = 0wx800: mode (* 04000 *)
                  val isgid = 0wx400: mode (* 02000 *)
               end

            structure O =
               struct
                  type flags = word
                  val append = 0wx400: flags (* 02000 *)
                  val creat = 0wx40: flags (* 0100 *)
                  val excl = 0wx80: flags (* 0200 *)
                  val noctty = 0wx100: flags (* 0400 *)
                  val nonblock = 0wx800: flags (* 04000 *)
                  val sync = 0wx1000: flags (* 010000 *)
                  val trunc = 0wx200: flags (* 01000 *)
               end

            val o_rdonly = 0wx0: word (* 00 *)
            val o_wronly = 0wx1: word (* 01 *)
            val o_rdwr = 0wx2: word (* 02 *)
            val R_OK_ = 0wx4: word (* 4 *)
            val W_OK_ = 0wx2: word (* 2 *)
            val X_OK_ = 0wx1: word (* 1 *)
            val F_OK_ = 0wx0: word (* 0 *)

            fun propertyLookup (s:string) : int option =
              case s
                of "LINK_MAX" => SOME 0
                 | "MAX_CANON" => SOME 1
                 | "MAX_INPUT" => SOME 2
                 | "NAME_MAX" => SOME 3
                 | "PATH_MAX" => SOME 4
                 | "PIPE_BUF" => SOME 5
                 | "CHOWN_RESTRICTED" => SOME 6
                 | "NO_TRUNC" => SOME 7
                 | "VDISABLE" => SOME 8
                 | _ => NONE

            structure Dirstream =
               struct
                  type dirstream = foreignptr (*built-in type*)

                  fun closedir (ds:dirstream) : int = prim("@closedir", ds)
                  fun opendir (s:string) : dirstream = prim("@opendir", s)
                  fun readdir (ds:dirstream) : cstring =
                    prim("Posix_FileSys_Dirstream_readdir", ds)
                  fun rewinddir (ds:dirstream) : unit = prim("@rewinddir", ds)
               end

            structure Stat =
               struct
                  fun dev():dev = prim("Posix_FileSys_Stat_dev", ())
                  fun ino():ino = prim("Posix_FileSys_Stat_ino", ())
                  fun mode():word = prim("Posix_FileSys_Stat_mode", ())
                  fun nlink():int = prim("Posix_FileSys_Stat_nlink", ())
                  fun uid():uid = prim("Posix_FileSys_Stat_uid", ())
                  fun gid():gid = prim("Posix_FileSys_Stat_gid", ())
                  fun size():int = prim("Posix_FileSys_Stat_size", ())
                  fun atime():time = prim("Posix_FileSys_Stat_atime", ())
                  fun mtime():time = prim("Posix_FileSys_Stat_mtime", ())
                  fun ctime():time = prim("Posix_FileSys_Stat_ctime", ())
                  fun fstat(fd:fd):int = prim("Posix_FileSys_Stat_fstat", fd)
                  fun lstat(s:string):int = prim("Posix_FileSys_Stat_lstat", s)
                  fun stat(s:string):int = prim("Posix_FileSys_Stat_stat", s)
               end

            structure Utimbuf =
               struct
                 fun setActime(t:time) : unit =
                   prim("Posix_FileSys_Utimbuf_setActime", t)
                 fun setModtime(t:time) : unit =
                   prim("Posix_FileSys_Utimbuf_setModTime", t)
                 fun utime(s:string):int =
                   prim("Posix_FileSys_Utimbuf_utime", s)
               end

            fun access (s:string, w:word) : int = prim("@access", (s,w))
            fun chdir (s:string): int = prim("@chdir", s)
            fun chmod (s:string,m:mode) : int = prim("@chmod", (s,m))
            fun chown (s:string,u:uid,g:gid): int = prim("@chown", (s,u,g))
            fun fchmod (fd:fd,m:mode):int = prim("@fchmod", (fd,m))
            fun fchown (fd:fd, u:uid, g:gid): int = prim("@fchown", (fd,u,g))
            fun fpathconf (fd:fd,i:int):int = prim("@fpathconf", (fd,i))
            fun ftruncate (fd:fd,i:int):int = prim("@ftruncate", (fd,i))
            fun getcwd ():string = prim("Posix_FileSys_getcwd", ())
            fun link {old:string,new:string} :int = prim("@link", (old,new))
            fun mkdir (s:string, w:word) : int = prim("@mkdir", (s,w))
            fun mkfifo (s:string, w:word): int = prim("@mkfifo", (s,w))
            fun openn (s:string,w:word,m:mode): fd = prim("@open", (s,w,m))
            fun pathconf (s:string,i:int):int = prim("@pathconf", (s,i))
            fun readlink (s:string):cstring =
              prim("Posix_FileSys_readlink", s)
            fun rename {old:string,new:string} :int = prim("@rename", (old,new))
            fun rmdir (s:string):int = prim("@rmdir", s)
            fun symlink {old:string,new:string}: int = prim("@symlink", (old,new))
            fun umask (w:word) : word = prim("@umask", w)
            fun unlink (s:string):int = prim("@unlink", s)

            structure ST =
               struct
                 fun isDir(w:word):bool = prim("Posix_FileSys_ST_isDir", w)
                 fun isChr(w:word):bool = prim("Posix_FileSys_ST_isChr", w)
                 fun isBlk(w:word):bool = prim("Posix_FileSys_ST_isBlk", w)
                 fun isReg(w:word):bool = prim("Posix_FileSys_ST_isReg", w)
                 fun isFIFO(w:word):bool = prim("Posix_FileSys_ST_isFIFO", w)
                 fun isLink(w:word):bool = prim("Posix_FileSys_ST_isLink", w)
                 fun isSock(w:word):bool = prim("Posix_FileSys_ST_isSock", w)
               end
         end

      structure IO =
         struct
            val F_DUPFD_ = 0: int
            val F_GETFD_ = 1: int
            val F_SETFD_ = 2: int
            val F_GETFL_ = 3: int
            val F_SETFL_ = 4: int
            val F_GETLK_ = 5: int
            val F_SETLK_ = 6: int
            val F_RDLCK_ = 0: int
            val F_WRLCK_ = 1: int
            val F_UNLCK_ = 2: int
            val F_SETLKW_ = 7: int
            val F_GETOWN_ = 9: int
            val F_SETOWN_ = 8: int
            val O_ACCMODE_ = 0wx3: word (* 0003 *)
            val SEEK_SET_ = 0: int
            val SEEK_CUR_ = 1: int
            val SEEK_END_ = 2: int

            structure FD =
               struct
                  type flags = word
                  val cloexec = 0w1: flags
               end

            type file_desc = file_desc
            type pid = pid

            structure FLock =
               struct
                 fun fcntl (fd:fd,i:int) : int = prim("Posix_IO_FLock_fcntl", (fd,i))
                 fun typ () : int = prim("Posix_IO_FLock_type", ())
                 fun whence () : int = prim("Posix_IO_FLock_whence", ())
                 fun start () : int = prim("Posix_IO_FLock_start", ())
                 fun len () : int = prim("Posix_IO_FLock_len", ())
                 fun pid () : int = prim("Posix_IO_FLock_pid", ())
                 fun setType (i:int) : unit = prim("Posix_IO_FLock_setType", i)
                 fun setWhence (i:int) : unit = prim("Posix_IO_FLock_setWhence", i)
                 fun setStart (i:int) : unit = prim("Posix_IO_FLock_setStart", i)
                 fun setLen (i:int) : unit = prim("Posix_IO_FLock_setLen", i)
                 fun setPid (i:int) : unit = prim("Posix_IO_FLock_setPid", i)
               end

            fun close (fd:fd) : int = prim("@close", fd)
            fun dup (fd:fd) : fd = prim("@dup", fd)
            fun dup2 (fd1:fd, fd2:fd) : fd = prim("@dup2", (fd1,fd2))
            fun fcntl2 (fd:fd,i:int) : int = prim("@fcntl", (fd,i))
            fun fcntl3 (fd:fd,i1:int,i2:int) : int = prim("@fcntl", (fd,i1,i2))
            fun fsync (fd:fd) : int = prim("@fsync", fd)
            fun lseek (fd:fd,i1:int,i2:int) : int= prim("@lseek", (fd,i1,i2))

            local
              type pipe = {infd:fd,outfd:fd}
              fun isNull (p: pipe) : bool = prim("__is_null", p)
              fun pipe0 () : pipe = prim("Posix_IO_pipe", ())
            in
              fun pipe () : pipe option =
                let val p = pipe0()
                in if isNull p then NONE
                   else SOME p
                end
            end

            fun readArr (fd:fd,buf:chararray,i:int,sz:size) : ssize =
              prim("Posix_IO_read", (fd,buf,i,sz))

            local
              fun alloc (n:int) : Word8Vector.vector =
                prim("allocStringML", n)
              fun read (fd:fd,buf:Word8Vector.vector,i:int,sz:size) : ssize =
                prim("Posix_IO_read", (fd,buf,i,sz))
              fun update_unsafe(s:Word8Vector.vector,i:int,c:char) : unit =
                prim("__bytetable_update", (s, i, c))
            in
              fun readVec(fd:fd, n:int) : Word8Vector.vector option =
                let val buf = alloc n
                  val i = read(fd, buf, 0, n)
                in if i = ~1 then NONE
                   else if i = n then (update_unsafe(buf,n,#"\000"); SOME buf)
                        else SOME (Word8Vector.extract(buf,0,SOME i))
                end
            end

            fun writeArr (fd:fd,buf:chararray,i:int,sz:size) : ssize =
              prim("Posix_IO_write", (fd,buf,i,sz))

            fun writeVec (fd:fd,buf:Word8Vector.vector,i:int,sz:size) : ssize =
              prim("Posix_IO_write", (fd,buf,i,sz))
         end

      structure ProcEnv =
         struct
            val numgroups = 100: int
            fun sysconfNameLookup s : int option =
              case s
                of "ARG_MAX" => SOME 0
                 | "CHILD_MAX" => SOME 1
                 | "CLK_TCK" => SOME 2
                 | "STREAM_MAX" => SOME 5
                 | "TZNAME_MAX" => SOME 6
                 | "OPEN_MAX" => SOME 4
                 | "JOB_CONTROL" => SOME 7
                 | "SAVED_IDS" => SOME 8
                 | "VERSION" => SOME 29
                 | "BC_BASE_MAX" => SOME 36
                 | "BC_DIM_MAX" => SOME 37
                 | "BC_SCALE_MAX" => SOME 38
                 | "BC_STRING_MAX" => SOME 39
                 | "COLL_WEIGHTS_MAX" => SOME 40
                 | "EXPR_NEST_MAX" => SOME 42
                 | "LINE_MAX" => SOME 43
                 | "RE_DUP_MAX" => SOME 44
                 | "2_VERSION" => SOME 46
                 | "2_FORT_DEV" => SOME 49
                 | "2_FORT_RUN" => SOME 50
                 | "2_SW_DEV" => SOME 51
                 | _ => NONE

            type pid = pid
            type gid = gid
            type uid = uid
            type file_desc = file_desc

            fun getegid () : gid = prim("@getegid", ())
            fun geteuid () : uid = prim("@geteuid", ())
            fun getgid () : gid = prim("@getgid", ())

            fun getgroups () : gid list = prim("Posix_ProcEnv_getgroups", ())

            fun getlogin () : cstring = prim("Posix_ProcEnv_getlogin", ())

            fun getpgrp () : pid = prim("@getpgrp", ())
            fun getpid () : pid = prim("@getpid", ())
            fun getppid () : pid = prim("@getppid", ())
            fun getuid () : uid = prim("@getuid", ())
            fun setenv (s1:string,s2:string) : int = prim("@setenv", (s1,s2,1))
            fun setgid (gid:gid) : int = prim("@setgid", gid)
            fun setpgid (p1:pid,p2:pid) : int = prim("@setpgid", (p1,p2))
            fun setsid () : pid = prim("@setsid", ())
            fun setuid (uid:uid) : int = prim("@setuid", uid)

            structure Uname =
              struct
                 (* type uname = pointer *)

                fun uname () : int = prim("Posix_ProcEnv_Uname_uname", ())
                fun sysname () : string = prim("Posix_ProcEnv_Uname_sysname", ())
                fun nodename () : string = prim("Posix_ProcEnv_Uname_nodename", ())
                fun release () : string = prim("Posix_ProcEnv_Uname_release", ())
                fun version () : string = prim("Posix_ProcEnv_Uname_version", ())
                fun machine () : string = prim("Posix_ProcEnv_Uname_machine", ())
              end

            type clock_t = word

            structure Tms =
               struct
                  fun utime () : clock_t = prim("Posix_ProcEnv_Tms_utime", ())
                  fun stime () : clock_t = prim("Posix_ProcEnv_Tms_stime", ())
                  fun cutime () : clock_t = prim("Posix_ProcEnv_Tms_cutime", ())
                  fun cstime () : clock_t = prim("Posix_ProcEnv_Tms_cstime", ())
               end

            fun ctermid () : string = prim("Posix_ProcEnv_ctermid", ())
            fun environ () : string list = rev(prim("Posix_ProcEnv_environ", ()))
            fun getenv (s:string) : cstring = prim("Posix_ProcEnv_getenv", s)
            fun isatty (fd:fd) : bool = prim("@isatty", fd)
            fun sysconf (i:int) : int = prim("@sysconf", i)
            fun times () : clock_t = prim("Posix_ProcEnv_times", ())
            fun ttyname (fd:fd) : cstring = prim("Posix_ProcEnv_ttyname", fd)
         end

      structure Process =
         struct
            val wnohang = 0wx1: word (* 1 *)
            structure W =
               struct
                  type flags = word
                  val untraced = 0wx2: flags (* 2 *)
               end

            type pid = pid
            type status = int

            fun alarm (i:int) : int = prim("@alarm", i)
            fun exec (s:string,e:string list) : int =
              prim("Posix_Process_exec", (s,e))
            fun exece (s:string,l1:string list,l2:string list) : int =
              prim("Posix_Process_exece", (s, l1, l2))
            fun execp (s:string,e:string list) : int =
               prim("Posix_Process_execp", (s,e))
            fun exit (i:int) : unit = prim("@exit", i)
            fun exitStatus (s:status) : int =
              prim("Posix_Process_exitStatus", s)
            fun fork () : pid = prim("@fork", ())
            fun ifExited (s:status) : bool = prim("Posix_Process_ifExited", s)
            fun ifSignaled (s:status) : bool = prim("Posix_Process_ifSignaled", s)
            fun ifStopped (s:status) : bool = prim("Posix_Process_ifStopped", s)
            fun kill (pid:pid,s:signal) : int = prim("@kill", (pid,s))
            fun pause () : int = prim("@pause", ())
            fun sleep (i:int) : int = prim("@sleep", i)
            fun stopSig (s:status) : signal = prim("Posix_Process_stopSig", s)
            fun termSig (s:status) : signal = prim("Posix_Process_termSig", s)
            fun waitpid (p:pid,i:int) : pid * status = prim("Posix_Process_waitpid", (p,i))
         end

      structure Signal =
         struct
            type signal = signal
            type how = int

            val abrt = 6: signal
            val alrm = 14: signal
            val bus = 7: signal
            val chld = 17: signal
            val cont = 18: signal
            val fpe = 8: signal
            val hup = 1: signal
            val ill = 4: signal
            val int = 2: signal
            val kill = 9: signal
            val pipe = 13: signal
            val prof = 27: signal
            val quit = 3: signal
            val segv = 11: signal
            val stop = 19: signal
            val term = 15: signal
            val tstp = 20: signal
            val ttin = 21: signal
            val ttou = 22: signal
            val usr1 = 10: signal
            val usr2 = 12: signal
            val vtalrm = 26: signal

            val block = 0: how
(*
            fun default (s:signal) : int =
              prim("Posix_Signal_default", s)
            fun handlee (s:signal) : int =
              prim("Posix_Signal_handle", s)
            fun ignore (s:signal) : int =
              prim("Posix_Signal_ignore", s)
            fun isDefault (s:signal) : bool =
              prim("Posix_Signal_isDefault", s)
            fun isPending (s:signal) : bool =
              prim("Posix_Signal_isPending", s)
*)
            val numSignals = 64: int
            val setmask = 2: how
(*
            fun sigaddset (s:signal) : int =
              prim("Posix_Signal_sigaddset", s)
            fun sigemptyset () : int =
              prim("Posix_Signal_sigemptyset", ())
            fun sigfillset () : int =
              prim("Posix_Signal_sigfillset", ())
            fun sigprocmask (h:how) : int =
              prim("Posix_Signal_sigprocmask", h)
*)
            val unblock = 1: how
         end

      structure SysDB =
         struct
            type gid = gid
            type uid = uid

            structure Passwd =
               struct
                  fun name () : string =
                    prim("Posix_SysDB_Passwd_name", ())
                  fun uid () : uid =
                    prim("Posix_SysDB_Passwd_uid", ())
                  fun gid () : gid =
                    prim("Posix_SysDB_Passwd_gid", ())
                  fun dir () : string =
                    prim("Posix_SysDB_Passwd_dir", ())
                  fun shell () : string =
                    prim("Posix_SysDB_Passwd_shell", ())
               end

            fun getpwnam (s:string) : bool =
              prim("Posix_SysDB_getpwnam", s)
            fun getpwuid (u:uid) : bool =
              prim("Posix_SysDB_getpwuid", u)

            structure Group =
              struct
                fun name () : string =
                  prim("Posix_SysDB_Group_name", ())
                fun gid () : gid =
                  prim("Posix_SysDB_Group_gid", ())
                fun mem () : string list =
                  prim("Posix_SysDB_Group_mem", ())
               end

            fun getgrgid (g:gid) : bool =
              prim("Posix_SysDB_getgrgid", g)
            fun getgrnam (s:string) : bool =
              prim("Posix_SysDB_getgrnam", s)
         end

      structure TTY =
         struct
            type speed = word
            val b0 = 0wx0: speed (* 0000000 *)
            val b110 = 0wx3: speed (* 0000003 *)
            val b1200 = 0wx9: speed (* 0000011 *)
            val b134 = 0wx4: speed (* 0000004 *)
            val b150 = 0wx5: speed (* 0000005 *)
            val b1800 = 0wxa: speed (* 0000012 *)
            val b19200 = 0wxe: speed (* 0000016 *)
            val b200 = 0wx6: speed (* 0000006 *)
            val b2400 = 0wxb: speed (* 0000013 *)
            val b300 = 0wx7: speed (* 0000007 *)
            val b38400 = 0wxf: speed (* 0000017 *)
            val b4800 = 0wxc: speed (* 0000014 *)
            val b50 = 0wx1: speed (* 0000001 *)
            val b600 = 0wx8: speed (* 0000010 *)
            val b75 = 0wx2: speed (* 0000002 *)
            val b9600 = 0wxd: speed (* 0000015 *)

            type pid = pid
            type file_desc = file_desc

            structure V =
               struct
                  val eof = 4: int
                  val eol = 11: int
                  val erase = 2: int
                  val intr = 0: int
                  val kill = 3: int
                  val min = 6: int
                  val nccs = 32: int
                  val quit = 1: int
                  val start = 8: int
                  val stop = 9: int
                  val susp = 10: int
                  val time = 5: int
               end

            structure I =
               struct
                  type flags = word
                  val brkint = 0wx2: flags (* 0000002 *)
                  val icrnl = 0wx100: flags (* 0000400 *)
                  val ignbrk = 0wx1: flags (* 0000001 *)
                  val igncr = 0wx80: flags (* 0000200 *)
                  val ignpar = 0wx4: flags (* 0000004 *)
                  val inlcr = 0wx40: flags (* 0000100 *)
                  val inpck = 0wx10: flags (* 0000020 *)
                  val istrip = 0wx20: flags (* 0000040 *)
                  val ixoff = 0wx1000: flags (* 0010000 *)
                  val ixon = 0wx400: flags (* 0002000 *)
                  val parmrk = 0wx8: flags (* 0000010 *)
               end

            structure O =
               struct
                  type flags = word
                  val opost = 0wx1: flags (* 0000001 *)
               end

            structure C =
               struct
                  type flags = word
                  val clocal = 0wx800: flags (* 0004000 *)
                  val cread = 0wx80: flags (* 0000200 *)
                  val cs5 = 0wx0: flags (* 0000000 *)
                  val cs6 = 0wx10: flags (* 0000020 *)
                  val cs7 = 0wx20: flags (* 0000040 *)
                  val cs8 = 0wx30: flags (* 0000060 *)
                  val csize = 0wx30: flags (* 0000060 *)
                  val cstopb = 0wx40: flags (* 0000100 *)
                  val hupcl = 0wx400: flags (* 0002000 *)
                  val parenb = 0wx100: flags (* 0000400 *)
                  val parodd = 0wx200: flags (* 0001000 *)
               end

            structure L =
               struct
                  type flags = word
                  val echo = 0wx8: flags (* 0000010 *)
                  val echoe = 0wx10: flags (* 0000020 *)
                  val echok = 0wx20: flags (* 0000040 *)
                  val echonl = 0wx40: flags (* 0000100 *)
                  val icanon = 0wx2: flags (* 0000002 *)
                  val iexten = 0wx8000: flags (* 0100000 *)
                  val isig = 0wx1: flags (* 0000001 *)
                  val noflsh = 0wx80: flags (* 0000200 *)
                  val tostop = 0wx100: flags (* 0000400 *)
               end

            structure TC =
               struct
                  type set_action = int

                  val sadrain = 1: set_action
                  val saflush = 2: set_action
                  val sanow = 0: set_action

                  type flow_action = int

                  val ion = 3: flow_action
                  val ioff = 2: flow_action
                  val ooff = 0: flow_action
                  val oon = 1: flow_action

                  type queue_sel = int

                  val iflush = 0: queue_sel
                  val ioflush = 2: queue_sel
                  val oflush = 1: queue_sel
               end

            structure Termios =
               struct
                  type flag = word

                  fun iflag () : flag =
                    prim("Posix_TTY_Termios_iflag", ())
                  fun oflag () : flag =
                    prim("Posix_TTY_Termios_oflag", ())
                  fun cflag () : flag =
                    prim("Posix_TTY_Termios_cflag", ())
                  fun lflag () : flag =
                    prim("Posix_TTY_Termios_lflag", ())
                  fun cc () : CharArray.array =
                    prim("Posix_TTY_Termios_cc", ())
                  fun setcc (cc:CharArray.array) : unit =
                    prim("Posix_TTY_Termios_setcc", cc)
                  fun ospeed () : speed =
                    prim("Posix_TTY_Termios_cfgetospeed", ())
                  fun ispeed () : speed =
                    prim("Posix_TTY_Termios_cfgetispeed", ())
                  fun setiflag (f:flag) : unit =
                    prim("Posix_TTY_Termios_setiflag", f)
                  fun setoflag (f:flag) : unit =
                    prim("Posix_TTY_Termios_setoflag", f)
                  fun setcflag (f:flag) : unit =
                    prim("Posix_TTY_Termios_setcflag", f)
                  fun setlflag (f:flag) : unit =
                    prim("Posix_TTY_Termios_setlflag", f)
                  fun setospeed (s:speed) : int =
                    prim("Posix_TTY_Termios_setospeed", s)
                  fun setispeed (s:speed) : int =
                    prim("Posix_TTY_Termios_setispeed", s)
               end

            fun getattr (fd:fd) : int =
              prim("Posix_TTY_getattr", fd)
            fun setattr (fd:fd,sa:TC.set_action) : int =
              prim("Posix_TTY_setattr", (fd,sa))
            fun sendbreak (fd:fd,i:int) : int = prim("@tcsendbreak", (fd,i))
            fun drain (fd:fd) : int = prim("@tcdrain", fd)
            fun flush (fd:fd,qs:TC.queue_sel) : int = prim("@tcflush", (fd,qs))
            fun flow (fd:fd,fa:TC.flow_action) : int = prim("@tcflow", (fd,fa))
            fun getpgrp (fd:fd) : pid = prim("@tcgetpgrp", fd)
            fun setpgrp (fd:fd,pid:pid) : int = prim("@tcsetpgrp", (fd,pid))
         end
   end
