/* Generate posix-enum.h file with defines for _SC_* enums. */

#include <unistd.h>
#include <stdio.h>
#include "posix-constants.h"

#define PP(X)   printf("#define " #X " %d\n", X)
#define PP_VAL(X)   printf("#define " #X"_VAL 0wx%x\n", X)

int
main()
{
  PP(_SC_ARG_MAX);
  PP(_SC_CHILD_MAX);
  PP(_SC_CLK_TCK);
  PP(_SC_STREAM_MAX);
  PP(_SC_TZNAME_MAX);
  PP(_SC_OPEN_MAX);
  PP(_SC_JOB_CONTROL);
  PP(_SC_SAVED_IDS);
  PP(_SC_VERSION);
  PP(_SC_BC_BASE_MAX);
  PP(_SC_BC_DIM_MAX);
  PP(_SC_BC_SCALE_MAX);
  PP(_SC_BC_STRING_MAX);
  PP(_SC_COLL_WEIGHTS_MAX);
  PP(_SC_EXPR_NEST_MAX);
  PP(_SC_LINE_MAX);
  PP(_SC_RE_DUP_MAX);
  PP(_SC_2_VERSION);
  PP(_SC_2_FORT_DEV);
  PP(_SC_2_FORT_RUN);
  PP(_SC_2_SW_DEV);

  PP(_PC_LINK_MAX);
  PP(_PC_MAX_CANON);
  PP(_PC_MAX_INPUT);
  PP(_PC_NAME_MAX);
  PP(_PC_PATH_MAX);
  PP(_PC_PIPE_BUF);
  PP(_PC_CHOWN_RESTRICTED);
  PP(_PC_NO_TRUNC);
  PP(_PC_VDISABLE);

  PP_VAL(Posix_FileSys_S_ifsock);
  PP_VAL(Posix_FileSys_S_iflnk);
  PP_VAL(Posix_FileSys_S_ifreg);
  PP_VAL(Posix_FileSys_S_ifblk);
  PP_VAL(Posix_FileSys_S_ifdir);
  PP_VAL(Posix_FileSys_S_ifchr);
  PP_VAL(Posix_FileSys_S_ififo);
  PP_VAL(Posix_FileSys_S_irwxu);
  PP_VAL(Posix_FileSys_S_irusr);
  PP_VAL(Posix_FileSys_S_iwusr);
  PP_VAL(Posix_FileSys_S_ixusr);
  PP_VAL(Posix_FileSys_S_irwxg);
  PP_VAL(Posix_FileSys_S_irgrp);
  PP_VAL(Posix_FileSys_S_iwgrp);
  PP_VAL(Posix_FileSys_S_ixgrp);
  PP_VAL(Posix_FileSys_S_irwxo);
  PP_VAL(Posix_FileSys_S_iroth);
  PP_VAL(Posix_FileSys_S_iwoth);
  PP_VAL(Posix_FileSys_S_ixoth);
  PP_VAL(Posix_FileSys_S_isuid);
  PP_VAL(Posix_FileSys_S_isgid);
  
  PP_VAL(Posix_FileSys_O_append);
  PP_VAL(Posix_FileSys_O_creat);
  PP_VAL(Posix_FileSys_O_excl);
  PP_VAL(Posix_FileSys_O_noctty);
  PP_VAL(Posix_FileSys_O_nonblock);
  PP_VAL(Posix_FileSys_O_sync);
  PP_VAL(Posix_FileSys_O_trunc);

  PP_VAL(Posix_FileSys_o_rdonly);
  PP_VAL(Posix_FileSys_o_wronly);
  PP_VAL(Posix_FileSys_o_rdwr);
  PP_VAL(Posix_FileSys_R_OK);
  PP_VAL(Posix_FileSys_W_OK);
  PP_VAL(Posix_FileSys_X_OK);
  PP_VAL(Posix_FileSys_F_OK);

  PP_VAL(Posix_IO_O_ACCMODE);
  PP_VAL(Posix_Process_wnohang);
  PP_VAL(Posix_Process_W_untraced);

  PP_VAL(Posix_TTY_b0);
  PP_VAL(Posix_TTY_b110);
  PP_VAL(Posix_TTY_b1200);
  PP_VAL(Posix_TTY_b134);
  PP_VAL(Posix_TTY_b150);
  PP_VAL(Posix_TTY_b1800);
  PP_VAL(Posix_TTY_b19200);
  PP_VAL(Posix_TTY_b200);
  PP_VAL(Posix_TTY_b2400);
  PP_VAL(Posix_TTY_b300);
  PP_VAL(Posix_TTY_b38400);
  PP_VAL(Posix_TTY_b4800);
  PP_VAL(Posix_TTY_b50);
  PP_VAL(Posix_TTY_b600);
  PP_VAL(Posix_TTY_b75);
  PP_VAL(Posix_TTY_b9600);
  
  PP_VAL(Posix_TTY_I_brkint);
  PP_VAL(Posix_TTY_I_icrnl);
  PP_VAL(Posix_TTY_I_ignbrk);
  PP_VAL(Posix_TTY_I_igncr);
  PP_VAL(Posix_TTY_I_ignpar);
  PP_VAL(Posix_TTY_I_inlcr);
  PP_VAL(Posix_TTY_I_inpck);
  PP_VAL(Posix_TTY_I_istrip);
  PP_VAL(Posix_TTY_I_ixoff);
  PP_VAL(Posix_TTY_I_ixon);
  PP_VAL(Posix_TTY_I_parmrk);
  
  PP_VAL(Posix_TTY_O_opost);
  
  PP_VAL(Posix_TTY_C_clocal);
  PP_VAL(Posix_TTY_C_cread);
  PP_VAL(Posix_TTY_C_cs5);
  PP_VAL(Posix_TTY_C_cs6);
  PP_VAL(Posix_TTY_C_cs7);
  PP_VAL(Posix_TTY_C_cs8);
  PP_VAL(Posix_TTY_C_csize);
  PP_VAL(Posix_TTY_C_cstopb);
  PP_VAL(Posix_TTY_C_hupcl);
  PP_VAL(Posix_TTY_C_parenb);
  PP_VAL(Posix_TTY_C_parodd);
  
  PP_VAL(Posix_TTY_L_echo);
  PP_VAL(Posix_TTY_L_echoe);
  PP_VAL(Posix_TTY_L_echok);
  PP_VAL(Posix_TTY_L_echonl);
  PP_VAL(Posix_TTY_L_icanon);
  PP_VAL(Posix_TTY_L_iexten);
  PP_VAL(Posix_TTY_L_isig);
  PP_VAL(Posix_TTY_L_noflsh);
  PP_VAL(Posix_TTY_L_tostop);
 
  return 0;
}
